
#ifndef DEFINIZ_H
#define DEFINIZ_H

typedef struct {
               double x,y,z;
               } puntua3;

typedef struct {
               double x,y,z;
               } bektorea3;

typedef struct {
               double r,g,b;
               } intentsitatea3;

/****************************************************************/
/****** GURE DATU EGITURAREN DEFINIZIOA  ************************/
/****************************************************************/

/*----------------------- ERPINA --------------------------------------*/

typedef struct {
    puntua3 koord;     /** koordenatuak ,x, y, z **/
    puntua3 kamara;
    double w;
    int    zenbataurpegitan;    /** zenbat aurpegitakoa den **/
    int   *tablacaras;     /** zein aurpegitakoa den **/
    int   *auztau;   /** zein diren bere alboko verticek **/
    bektorea3 normal;   /** puntuari dagokion normala **/
    intentsitatea3 intentsitatea; /** puntuari dagokion intentsitatea **/
} vertice;

/*----------------------- CARA ---------------------------------------*/

typedef struct {
    int numvert;    /** zenbat erpin dauzkan **/
    int *tablaindvert;  /** verticek, erpin-taulan
                          bakoitzak duen indizea **/
    int aurauzokop;  /** alboko aurpegi kopurua **/
    int *auztau;   /** alboko carak **/
    bektorea3 normal;  /** carari dagokion normala: kamararen erreferentzi sisteman **/
    bektorea3 normala; /** carari dagokion normala **/
    int aurrera_begira;
    intentsitatea3 intentsitatea;
    long kolorea;
    void* hackdata;  /* hack bat egiteko datu punteroa (phong eta goureau) */
} cara;

/*----------------------- OBJEKTUA -----------------------------------------*/
typedef struct {
    int numvert;  /** objektu baten erpin kopurua **/
    vertice *tablavert;   /** erpin-taula **/
    int numcaras;   /** objektu baten aurpegi kopurua **/
    cara *tablacaras;       /** aurpegi-taula **/
    int alderantziz;        // objetua alderantziz marraztu behar den ... (islarako)
    puntua3 min;            // objetuaren koordenatu minimoak
    puntua3 max;            // objetuaren koordenatu maximoak
} objektua;

/*----------------------- KAMERA -----------------------------------------*/
/*----------------------- ARGIA -----------------------------------------*/
/*----------------------- ARGILISTA -----------------------------------------*/

#endif // DEFINIZ_H
