
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "main.h"
#include "definiz.h"
#include "wavefrontirakurri.h"
#include "kamara.h"
#include "menua.h"

static void get_main_menu(GtkWidget *window, GtkWidget ** menubar);
static void destroy(GtkWidget *widget,gpointer data);

static GtkWidget *window;
static GtkWidget *main_vbox,*bistak_vbox;
static GtkWidget *menubar;
static GtkWidget *pnd_kamara;


static GtkItemFactoryEntry menu_items[] = {
    {"/Fichero",                       NULL,         NULL,                           0, "<Branch>"},
    {"/Fichero/_Nuevo Objeto",   "<alt>N",     menua_ireki,                    0, NULL},
    {"/Fichero/_Anadir Objeto",     "<alt>A",     menua_gehitu,                   0, NULL},
    {"/Fichero/Eliminar Objeto",      "<alt>X",     menua_kendu,                    0, NULL},
    {"/Fichero/sep1",                   NULL,         NULL,                           0, "<Separator>"},
    {"/Fichero/Salir",                 "<alt>Q",     GTK_SIGNAL_FUNC(menua_atera),   0, NULL},
    {"/Luces",                             NULL,         NULL,                           0, "<Branch>"},
    {"/Luces/Anadir",                NULL,         menua_argiagehitu,              0, NULL},
    {"/Luces/Eliminar",                 NULL,         menua_argiakendu,               0, NULL},
    {"/Luces/configurar",           NULL,         menua_argiakonfiguratu,         0, NULL},
    {"/_Objeto",                          NULL,         NULL,                           0, "<Branch>"},
    {"/Objeto/Ver - Ocultar",             NULL,         menua_ikusigorde,                           0, NULL},
    {"/Objeto/Ver Informacion",         NULL,         menua_informazioa,              0, NULL},
    {"/Transformaciones",                        NULL,         NULL,                           0, "<Branch>"},
    {"/Transformaciones/_Trasladar",           "<control>T", menu_traslacion,              0, NULL},
    {"/Transformaciones/_Escalar",         "<control>E", menu_escalar,            0, NULL},
    {"/Transformaciones/_Rotacion",                 "<control>R", menu_rotacion,                   0, NULL},
    {"/Transformaciones/Re_flejo",                 "<control>F", menu_reflejar,                   0, NULL},
//    {"/Aldaketak/_Epizentroa erdira",      "<control>E", menua_epizentroaerdira,         0, NULL},
    {"/Transformaciones/_Deshacer",                "<control>Z", menu_undo,                  0, NULL},
    {"/_Camara",                           NULL,         NULL,                           0, "<Branch>"},
    {"/Camara/_PHIGS",                     "<control>P", menua_PHIGSkamara,              0, NULL},
    {"/Camara/Free Focus",             NULL, menua_kamaratontoa,             0, NULL},
    {"/Camara/sep1",                       NULL,         NULL,                           0, "<Separator>"},
    {"/Camara/Eliminar Caras Traseras",   NULL, menua_atzeaurpegiakezabatu,     0, "<ToggleItem>"},
    {"/Camara/Invertir direccion de caras", NULL,         menua_atzeaurpegiakalderantziz, 0, NULL},
    {"/Camara/sep2",                       NULL,         NULL,                           0, "<Separator>"},
    {"/Camara/Configurar camara",         NULL,         menua_kamarakonfiguratu,        0, NULL},
    {"/Camara/Configurar Vistas",         NULL,         menua_bistakkonfiguratu,        0, NULL},
    {"/_Help",                         NULL,         NULL,                           0, "<LastBranch>"},
    {"/Help/Acerca de...",         NULL,         menua_zerariburuz,              0, NULL},
};



static void get_main_menu(GtkWidget *window, GtkWidget ** menubar)
{
    int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
    GtkAccelGroup *accel_group;

    accel_group = gtk_accel_group_new();

    item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",
                                        accel_group);
    gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);

    gtk_accel_group_attach (accel_group, GTK_OBJECT (window));

    if (menubar)
        *menubar = gtk_item_factory_get_widget(item_factory, "<main>");
}
/************************************************************/

static void destroy( GtkWidget *widget, gpointer data )
{
    gtk_main_quit();
}

int main( int argc, char *argv[] )
{
    GtkWidget *lag;
    gint context_id;
    //objektua  obj;

    /* objetuaren hasieraketak */

    if (WaveFrontIrakurri("abioia.obj",&obj))
    {
        printf("Ezin dut objektua irakurri: abioia.obj\n");
        obj.numvert = 0;
        obj.numcaras = 0;
    } else {
        printf("Objetua kargatu da: abioia\n");
    }

    /* GTK-ren hasieraketak */
    
    gtk_init(&argc, &argv);
    gdk_rgb_init();
    
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
    gtk_window_set_title(GTK_WINDOW(window), "Konputagailu Bidezko Grafikoak");
    gtk_widget_set_usize(GTK_WIDGET(window), 800, 660);
    gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
    
    gtk_signal_connect (GTK_OBJECT (window), "delete_event",
			GTK_SIGNAL_FUNC (menua_atera), NULL);
    
    gtk_signal_connect (GTK_OBJECT (window), "destroy",
			GTK_SIGNAL_FUNC (destroy), NULL);
    
    gtk_container_set_border_width (GTK_CONTAINER (window), 0);

    main_vbox = gtk_vbox_new(FALSE, 1);
    gtk_container_border_width(GTK_CONTAINER(main_vbox), 0);
    gtk_container_add(GTK_CONTAINER(window), main_vbox);

    pnd_kamara = gtk_hpaned_new();
    gtk_paned_set_gutter_size(GTK_PANED(pnd_kamara),8);
    gtk_paned_set_handle_size(GTK_PANED(pnd_kamara),8);
    
//    kamara_hbox = gtk_hbox_new(FALSE, 1);
//    gtk_container_border_width(GTK_CONTAINER(kamara_hbox), 0);

    bistak_vbox = gtk_vbox_new(FALSE, 1);
    gtk_container_border_width(GTK_CONTAINER(bistak_vbox), 0);

    darea1 = gtk_drawing_area_new ();
    gtk_drawing_area_size (GTK_DRAWING_AREA (darea1), 600, 600);
    
//    gtk_box_pack_start (GTK_BOX (kamara_hbox), darea1, FALSE, FALSE, 1);

    darea2 = gtk_drawing_area_new ();
    gtk_drawing_area_size (GTK_DRAWING_AREA (darea2), 200, 200);
    gtk_box_pack_start (GTK_BOX (bistak_vbox), darea2, TRUE, TRUE, 1);
    darea3 = gtk_drawing_area_new ();
    gtk_drawing_area_size (GTK_DRAWING_AREA (darea3), 200, 200);
    gtk_box_pack_start (GTK_BOX (bistak_vbox), darea3, TRUE, TRUE, 1);
    darea4 = gtk_drawing_area_new ();
    gtk_drawing_area_size (GTK_DRAWING_AREA (darea4), 200, 200);
    gtk_box_pack_start (GTK_BOX (bistak_vbox), darea4, TRUE, TRUE, 1);

//    gtk_box_pack_start (GTK_BOX (kamara_hbox), bistak_vbox, TRUE, TRUE, 1);
//    gtk_box_pack_start (GTK_BOX (kamara_hbox), darea1, TRUE, TRUE, 1);
    gtk_paned_add1(GTK_PANED(pnd_kamara),bistak_vbox);
    gtk_paned_add2(GTK_PANED(pnd_kamara),darea1);

    gtk_signal_connect (GTK_OBJECT (darea1), "expose_event",
                        (GtkSignalFunc) darea1_expose_event, NULL);
    gtk_widget_set_events (darea1, GDK_EXPOSURE_MASK);
    gtk_signal_connect (GTK_OBJECT (darea2), "expose_event",
                        (GtkSignalFunc) darea2_expose_event, NULL);
    gtk_widget_set_events (darea2, GDK_EXPOSURE_MASK);
    gtk_signal_connect (GTK_OBJECT (darea3), "expose_event",
                        (GtkSignalFunc) darea3_expose_event, NULL);
    gtk_widget_set_events (darea3, GDK_EXPOSURE_MASK);
    gtk_signal_connect (GTK_OBJECT (darea3), "expose_event",
                        (GtkSignalFunc) darea3_expose_event, NULL);
    gtk_widget_set_events (darea3, GDK_EXPOSURE_MASK);
    gtk_signal_connect (GTK_OBJECT (darea4), "expose_event",
                        (GtkSignalFunc) darea4_expose_event, NULL);
    gtk_widget_set_events (darea4, GDK_EXPOSURE_MASK);

//    men = g
    get_main_menu(window, &menubar);
    lag = gtk_item_factory_get_item(item_factory,"/Kamara/Atze aurpegiak ezkutatu");
    if (lag != NULL) {
//        gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(lag),FALSE);
        GTK_CHECK_MENU_ITEM(lag)->active = 1;
        //nerekam.aurpegiakezkutatu = 1;
    }
    
    gtk_box_pack_start(GTK_BOX(main_vbox), menubar, FALSE, FALSE, 0);
//    gtk_box_pack_start(GTK_BOX(main_vbox), kamara_hbox, TRUE, TRUE, 1);
    gtk_box_pack_start(GTK_BOX(main_vbox), pnd_kamara, TRUE, TRUE, 1);
//    gtk_container_add (GTK_CONTAINER (window), button);
    status_bar = gtk_statusbar_new();
    gtk_box_pack_start (GTK_BOX (main_vbox), status_bar, FALSE, FALSE, 0);
    gtk_widget_show (GTK_WIDGET(status_bar));

    context_id = gtk_statusbar_get_context_id(GTK_STATUSBAR(status_bar), "Statusbar example");
    gtk_statusbar_push(GTK_STATUSBAR(status_bar), context_id, " Konputagailu Bidezko Grafikoak");
    

    gtk_widget_show(darea1);
    gtk_widget_show(darea2);
    gtk_widget_show(darea3);
    gtk_widget_show(darea4);
    gtk_widget_show(bistak_vbox);
    gtk_widget_show(pnd_kamara);
//    gtk_widget_show(kamara_hbox);
    gtk_widget_show(menubar);
    gtk_widget_show(main_vbox);
    gtk_widget_show(window);

    gtk_main ();

    return(0);
}

