
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;


/************************************************************/
static void traslacion_cmd_accept_clicked( GtkWidget *widget, gpointer   data )
{
    puntua3 p;
    char str[100];

    p.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    p.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    p.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    gtk_widget_destroy(GTK_WIDGET(widget));

    sprintf(str,"(%.2f,%.2f,%.2f) mugitzeko programatu egin behar duzu",p.x,p.y,p.z);
    mezua("Abixua",str,mezuaONARTU,NULL);

    redraw();
}

void menu_traslacion(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*xhbox,*yhbox,*zhbox,*action_hbox;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x,*lbl_y,*lbl_z;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);
    

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Lekuz aldatu");
    gtk_widget_set_usize(lei,240,220);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,0);
    xhbox = gtk_hbox_new(FALSE,0);
    yhbox = gtk_hbox_new(FALSE,0);
    zhbox = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);

    lbl_mezua = gtk_label_new("Cantidad a trasladar:");
    
    lbl_x = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(xhbox), lbl_x, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(yhbox),lbl_y,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(zhbox),lbl_z,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(zhbox), spn_pz, TRUE, TRUE, 20);

    cmd_accept = gtk_button_new_with_label ("OK");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (traslacion_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Cancel");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);

    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),zhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z);
    gtk_widget_show(spn_pz);
    gtk_widget_show(xhbox);
    gtk_widget_show(yhbox);
    gtk_widget_show(zhbox);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void escalar_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    char str[100];
    puntua3 p1,p2;

    p1.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    p1.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    p1.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    p2.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
    p2.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));
    p2.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2z));


    sprintf(str,"(%.2f,%.2f,%.2f) aldatzeko programatu egin behar duzu",p1.x,p1.y,p1.z);
    mezua("Abixua",str,mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menu_escalar(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1,*vbox_frm2;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox,*action_hbox;
    GtkWidget *frm_p1,*frm_p2;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);
    

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Tamaina aldatu");
    gtk_widget_set_usize(lei,390,255);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);
    frm_p1 = gtk_frame_new("Punto a mantener:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Cambio de escala:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);

    lbl_mezua = gtk_label_new("Elige el cambio de escala:");

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, 0.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, 0.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, 0.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    cmd_accept = gtk_button_new_with_label ("OK");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (escalar_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Cancel");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p2,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void rotacion_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    puntua3 p;
    bektorea3 v;
    int gr;
    char str[100];

    p.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    p.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    p.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    v.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
    v.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));
    v.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2z));

    gr = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(spn_graduak));

    sprintf(str,"%d gradu biratzeko programatu egin behar duzu",gr);
    mezua("Abixua",str,mezuaONARTU,NULL);

    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menu_rotacion(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1,*vbox_frm2,*hbox_graduak,*vbox_graduak;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox,*action_hbox;
    GtkWidget *frm_p1,*frm_p2,*frm_graduak;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2,*lbl_graduak;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);
    

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Biratu");
    gtk_widget_set_usize(lei,390,340);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 20);


    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    vbox_graduak = gtk_vbox_new(FALSE,0);
    hbox_graduak = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);
    frm_p1 = gtk_frame_new("Punto del eje:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Vector de direccion:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);
    frm_graduak = gtk_frame_new("grados a rotar:");
    gtk_frame_set_label_align(GTK_FRAME(frm_graduak),0.0,0.0);

    lbl_mezua = gtk_label_new("Eje de rotacion:");

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    lbl_graduak = gtk_label_new("Grados:");
    gtk_box_pack_start(GTK_BOX(hbox_graduak),lbl_graduak,FALSE,FALSE,60);
    
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -360.0, 360.0, 5.0, 45.0, 0.0);
    spn_graduak = gtk_spin_button_new(adj,0,0);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start(GTK_BOX(hbox_graduak),spn_graduak, FALSE, FALSE, 5);
    gtk_box_pack_start(GTK_BOX(vbox_graduak),hbox_graduak,FALSE,FALSE,5);
    gtk_container_add (GTK_CONTAINER(frm_graduak), vbox_graduak);


    cmd_accept = gtk_button_new_with_label ("OK");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (rotacion_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Cancel");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p1,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p2,TRUE,TRUE,0);
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,0);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),frm_graduak,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(lbl_graduak);
    gtk_widget_show(spn_graduak);
    gtk_widget_show(hbox_graduak);
    gtk_widget_show(vbox_graduak);
    gtk_widget_show(frm_graduak);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void reflejar_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    puntua3 p;
    bektorea3 v1,v2,bek;
    int mota;
    double d;
    char str[100];

    mota = gtk_notebook_get_current_page(GTK_NOTEBOOK(ntbk_planoa));

    if (mota == 0)  // puntua eta bi bektore
    {
        p.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
        p.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
        p.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));
        v1.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
        v1.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));
        v1.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2z));
        v2.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3x));
        v2.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3y));
        v2.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3z));
        if ((v1.x || v1.y || v1.z) && (v2.x || v2.y || v2.z))
        {
            bek.x = v1.y * v2.z - v1.z * v2.y;
            bek.y = v1.z * v2.x - v1.x * v2.z;
            bek.z = v1.x * v2.y - v1.y * v2.x;
        }
    } else if (mota == 1) {  // funtzio matematikoa
        bek.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_a));
        bek.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_b));
        bek.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_c));
        d = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_d));

        if (bek.x || bek.y || bek.z)
        {
            if (d == 0.0)    // planoa jatorritik pasatzen da, bestela planoko puntu bat lortu
            {
                p.x = 0.0;
                p.y = 0.0;
                p.z = 0.0;
            } else if (bek.z != 0) {   // (0,0,z) motako puntua lortzeko. C!=0 behar da,
                                       // bestela planua z ardatzaren paralelo da eta ez du soluziorik
                p.x = 0.0;
                p.y = 0.0;
                p.z = -d/bek.z;
            } else if (bek.y != 0) {   // berdin (0,y,0)-rekin
                p.x = 0.0;
                p.y = -d/bek.y;
                p.z = 0.0;
            } else {                   // A!=0 da, bestela ez duzu planurik
                p.x = -d/bek.x;
                p.y = 0.0;
                p.z = 0.0;
            }
        }
    } else {
        gtk_widget_destroy(GTK_WIDGET(widget));
        redraw();
        return;
    }

    sprintf(str,"(%.2f,%.2f,%.2f) normalarekiko islatzeko programatu egin behar duzu",bek.x,bek.y,bek.z);
    mezua("Abixua",str,mezuaONARTU,NULL);

    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menu_reflejar(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*vbox_bek,*hbox_bek,*hbox_math,*vbox_math,*hbox_action;
    GtkWidget *vbox_frm1,*vbox_frm2;
    GtkWidget *pxhbox, *pyhbox, *pzhbox;
    GtkWidget *v1xhbox,*v1yhbox,*v1zhbox;
    GtkWidget *hbox_row1,*hbox_row2;
    GtkWidget *lbl_a,*lbl_b,*lbl_c,*lbl_d;
    GtkWidget *frm_p,*frm_v1;
    GtkWidget *lbl_mezua,*lbl_math,*lbl_bek,*lbl_formula;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2,*lbl_x3,*lbl_y3,*lbl_z3;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Islada");
    gtk_widget_set_usize(lei,590,320);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 20);

    vbox = gtk_vbox_new(FALSE,0);
    hbox_bek = gtk_hbox_new(FALSE,0);
    vbox_bek = gtk_vbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    pxhbox = gtk_hbox_new(FALSE,0);
    pyhbox = gtk_hbox_new(FALSE,0);
    pzhbox = gtk_hbox_new(FALSE,0);
    v1xhbox = gtk_hbox_new(FALSE,0);
    v1yhbox = gtk_hbox_new(FALSE,0);
    v1zhbox = gtk_hbox_new(FALSE,0);
    vbox_math = gtk_vbox_new(FALSE,0);
    hbox_math = gtk_hbox_new(FALSE,0);
    hbox_row1 = gtk_hbox_new(FALSE,0);
    hbox_row2 = gtk_hbox_new(FALSE,0);
    hbox_action = gtk_hbox_new(FALSE,0);

    frm_p = gtk_frame_new("Punto del plano:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p),0.5,0.0);
    frm_v1 = gtk_frame_new("Dos vectores del plano:");
    gtk_frame_set_label_align(GTK_FRAME(frm_v1),0.5,0.0);

    lbl_mezua = gtk_label_new("Plano:");

    ntbk_planoa = gtk_notebook_new();
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(ntbk_planoa),GTK_POS_TOP);
    gtk_notebook_set_show_border(GTK_NOTEBOOK(ntbk_planoa),TRUE);
    gtk_notebook_set_show_tabs(GTK_NOTEBOOK(ntbk_planoa),TRUE);
    
    lbl_bek = gtk_label_new("Punto y dos vectores");
    lbl_math = gtk_label_new("Funcion matematica");

    gtk_notebook_append_page(GTK_NOTEBOOK(ntbk_planoa),GTK_WIDGET(vbox_bek),GTK_WIDGET(lbl_bek));
    gtk_notebook_append_page(GTK_NOTEBOOK(ntbk_planoa),GTK_WIDGET(hbox_math),GTK_WIDGET(lbl_math));

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(pxhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(pxhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(pyhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(pyhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(pzhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(pzhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),pxhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),pyhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),pzhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p), vbox_frm1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(v1xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1xhbox), spn_p2x, TRUE, TRUE, 20);
    lbl_x3 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(v1xhbox), lbl_x3, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1xhbox), spn_p3x, TRUE, TRUE, 20);
    
    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(v1yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1yhbox), spn_p2y, TRUE, TRUE, 20);
    lbl_y3 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(v1yhbox),lbl_y3,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1yhbox), spn_p3y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(v1zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1zhbox), spn_p2z, TRUE, TRUE, 20);
    lbl_z3 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(v1zhbox),lbl_z3,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(v1zhbox), spn_p3z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm2),v1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),v1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),v1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_v1), vbox_frm2);

    gtk_box_pack_start(GTK_BOX(hbox_bek),frm_p,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_bek),frm_v1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_bek),hbox_bek,TRUE,TRUE,10);

    lbl_formula = gtk_label_new("Ax + By + Cz + D = 0");

    lbl_a = gtk_label_new("A");
    gtk_box_pack_start(GTK_BOX(hbox_row1),lbl_a,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_a = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_a), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_a),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_row1), spn_a, TRUE, TRUE, 20);

    lbl_b = gtk_label_new("B");
    gtk_box_pack_start(GTK_BOX(hbox_row1),lbl_b,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_b = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_b), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_b),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_row1), spn_b, TRUE, TRUE, 20);

    lbl_c = gtk_label_new("C");
    gtk_box_pack_start(GTK_BOX(hbox_row2),lbl_c,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_c = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_c), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_c),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_row2), spn_c, TRUE, TRUE, 20);

    lbl_d = gtk_label_new("D");
    gtk_box_pack_start(GTK_BOX(hbox_row2),lbl_d,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_d = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_d), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_d),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_row2), spn_d, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_math),lbl_formula,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_math),hbox_row1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_math),hbox_row2,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(hbox_math),vbox_math,TRUE,TRUE,10);

    cmd_accept = gtk_button_new_with_label ("OK");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (reflejar_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Cancel");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));

    gtk_box_pack_start(GTK_BOX(hbox_action),cmd_accept,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(hbox_action),cmd_cancel,TRUE,TRUE,0);

    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),ntbk_planoa,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_action,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(pxhbox);
    gtk_widget_show(pyhbox);
    gtk_widget_show(pzhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(v1xhbox);
    gtk_widget_show(v1yhbox);
    gtk_widget_show(v1zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_v1);
    gtk_widget_show(lbl_x3);
    gtk_widget_show(spn_p3x);
    gtk_widget_show(lbl_y3);
    gtk_widget_show(spn_p3y);
    gtk_widget_show(lbl_z3);
    gtk_widget_show(spn_p3z);
    gtk_widget_show(hbox_bek);
    gtk_widget_show(vbox_bek);
    gtk_widget_show(lbl_formula);
    gtk_widget_show(lbl_a);
    gtk_widget_show(spn_a);
    gtk_widget_show(lbl_b);
    gtk_widget_show(spn_b);
    gtk_widget_show(hbox_row1);
    gtk_widget_show(lbl_c);
    gtk_widget_show(spn_c);
    gtk_widget_show(lbl_d);
    gtk_widget_show(spn_d);
    gtk_widget_show(hbox_row2);
    gtk_widget_show(vbox_math);
    gtk_widget_show(hbox_math);
    gtk_widget_show(lbl_bek);
    gtk_widget_show(lbl_math);
    gtk_widget_show(ntbk_planoa);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(hbox_action);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}

/************************************************************/
void menu_undo(GtkWidget *widget, gpointer data)
{

    mezua("Error","Para deshacer hay que hacer... algo",mezuaONARTU,NULL);
        
    redraw();
}
/************************************************************/
