
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

/*
GnomeUIInfo menua_fitxategia[] = {
    { GNOME_APP_UI_ITEM,
      "_Ireki", "Objetu berria ireki",
      menua_ireki, NULL, NULL,
      GNOME_APP_PIXMAP_NONE, NULL, 0, 0,NULL},
    { GNOME_APP_UI_ITEM,
      "_Gehitu", "Objetu bat gehitu",
      menua_gehitu, NULL, NULL,
      GNOME_APP_PIXMAP_NONE, NULL, 0, 0,NULL},
    { GNOME_APP_UI_ITEM,
      "_Kendu", "Objetu bat kendu",
      NULL, NULL, NULL,
      GNOME_APP_PIXMAP_NONE, NULL, 0, 0,NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM,
      "_Atera", "Programatik atera",
      GTK_SIGNAL_FUNC(menua_atera), NULL, NULL,
      GNOME_APP_PIXMAP_NONE, NULL, 0, 0,NULL},
    GNOMEUIINFO_END
}
*/
extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;
extern GtkWidget *cmb_lista;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;

extern objektua obj;


/************************************************************/
static void ireki_okbutton( GtkWidget *widget, GtkFileSelection *data )
{
    char buf[200];

    sprintf(buf,"objektu berria %s fitxategitik irakurtzeko programatu egin behar duzu",gtk_file_selection_get_filename (GTK_FILE_SELECTION (data)));
    mezua("abixua",buf,mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(data));
    redraw();
}

static void ireki_cancelbutton( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(data));
}

void menua_ireki( GtkWidget *widget, gpointer data)
{
    GtkWidget *filew;
    
    filew = gtk_file_selection_new ("KBG - Fitxategia ireki");

    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) ireki_okbutton, filew );
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
                        "clicked", (GtkSignalFunc) ireki_cancelbutton, filew);
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), 
                                     "abioia.obj");
    gtk_widget_show(filew);
}
/************************************************************/
static void gehitu_mezuacallback(int mota,void *data)
{
    switch (mota) {
    case mezuaONARTU:
        if (data != NULL)
            {
            mezua("Oharra","Oharra: Izena hutsa dago, idatzi berria:",mezuaONARTU|mezuaEZEZTATU|mezuaTESTUA,gehitu_mezuacallback);
            } else {
                mezua("Oharra","objektua listaratu da...",mezuaONARTU,NULL);
                redraw();
            }
        break;
    case mezuaEZEZTATU:
    case mezuaITXIA:
        if (data != NULL)
            free(data);
        break;
    default:
        if (data != NULL)
            free(data);
        break;
    }
}

static void gehitu_okbutton( GtkWidget *widget, GtkFileSelection *data )
{
    char buf[200];

    sprintf(buf,"objektu berria %s fitxategitik gehitzeko programatu egin behar duzu",gtk_file_selection_get_filename (GTK_FILE_SELECTION (data)));
    mezua("abixua",buf,mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(data));
    redraw();
}

static void gehitu_cancelbutton( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(data));
}

void menua_gehitu( GtkWidget *widget, gpointer data)
{
    GtkWidget *filew;
    
    filew = gtk_file_selection_new ("KBG - Fitxategia gehitu");

    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) gehitu_okbutton, filew );
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
                        "clicked", (GtkSignalFunc) gehitu_cancelbutton, filew);
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), 
                                     "abioia.obj");
    gtk_widget_show(filew);
}
/************************************************************/
static void kendu_okbutton( GtkWidget *widget, gpointer data )
{
    char *izena;
    char buf[100];

    izena = strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cmb_lista)->entry)));
    sprintf(buf,"%s izena duen aobjektua kendu nahi duzu",izena);
    mezua("oharra",buf,mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(widget));
    free(izena);
    redraw();
}

static void kendu_cancelbutton( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(data));
}

void menua_kendu(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox;
    GtkWidget *lbl_aukera;
    GtkWidget *cmd_accept,*cmd_cancel;

    GList *glist;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);
    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Objetua Kendu");
    gtk_widget_set_usize(lei,210,200);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,10);
    hbox = gtk_hbox_new(FALSE,0);

    lbl_aukera = gtk_label_new("Aukeratu objetua:");

    glist = NULL;
    glist = g_list_append(glist,"abioia");
    glist = g_list_append(glist,"beste objekturen bat");
    glist = g_list_append(glist,"iruditxoa");
    glist = g_list_append(glist,"...");
    
    cmb_lista = gtk_combo_new();
    gtk_combo_set_popdown_strings(GTK_COMBO(cmb_lista),glist);
    gtk_combo_set_case_sensitive(GTK_COMBO(cmb_lista),TRUE);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (kendu_okbutton),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_signal_connect (GTK_OBJECT (lei), "destroy",
                        GTK_SIGNAL_FUNC (kendu_cancelbutton), GTK_OBJECT(lei));

    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);

    gtk_container_add (GTK_CONTAINER (lei),vbox);
    gtk_box_pack_start(GTK_BOX(vbox),lbl_aukera,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),cmb_lista,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox),cmd_accept,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(hbox),cmd_cancel,TRUE,TRUE,0);

    gtk_widget_show (cmd_accept);
    gtk_widget_show (cmd_cancel);
    gtk_widget_show (lbl_aukera);
    gtk_widget_show (cmb_lista);

    gtk_widget_show (hbox);
    gtk_widget_show (vbox);

    gtk_widget_show (lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}

/************************************************************/
static void cmd_bai_clicked( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(widget));
    gtk_main_quit();
}

static void cmd_ez_clicked( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(widget));
}

gint menua_atera( GtkWidget *widget, GdkEvent *event, gpointer data )
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox;
    GtkWidget *lbl_galdera;
    GtkWidget *cmd_bai,*cmd_ez;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Atera");
    gtk_widget_set_usize(lei,200,100);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,0);
    hbox = gtk_hbox_new(FALSE,0);

    lbl_galdera = gtk_label_new("Atera nahi duzu?");
    
    cmd_bai = gtk_button_new_with_label ("Bai");
    cmd_ez = gtk_button_new_with_label ("Ez");

    gtk_signal_connect (GTK_OBJECT (lei), "destroy",
                        GTK_SIGNAL_FUNC (cmd_ez_clicked), GTK_OBJECT(lei));

    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);

    gtk_signal_connect_object (GTK_OBJECT (cmd_bai), "clicked",
                               GTK_SIGNAL_FUNC (cmd_bai_clicked),
                               GTK_OBJECT (lei));

    gtk_signal_connect_object (GTK_OBJECT (cmd_ez), "clicked",
                               GTK_SIGNAL_FUNC (cmd_ez_clicked),
                               GTK_OBJECT (lei));

    gtk_container_add (GTK_CONTAINER (lei),vbox);
    gtk_box_pack_start(GTK_BOX(vbox),lbl_galdera,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox),cmd_bai,TRUE,TRUE,0);
    gtk_box_pack_start(GTK_BOX(hbox),cmd_ez,TRUE,TRUE,0);

    gtk_widget_show (cmd_bai);
    gtk_widget_show (cmd_ez);
    gtk_widget_show (lbl_galdera);
    
    gtk_widget_show (hbox);
    gtk_widget_show (vbox);
    
    gtk_widget_show (lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));

    return TRUE;
}
