
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;
extern GtkWidget *rdb_ertz, *rdb_span, *rdb_ray;
extern GtkWidget *rdb_flat, *rdb_gouraud, *rdb_phong;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;


/************************************************************/
static void PHIGSkamara_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    puntua3 VRP,PRP,VPN,VUP;
    double d,n,f,xmax,xmin,ymax,ymin;
    int paraleloa;

    VRP.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    VRP.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    VRP.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    PRP.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
    PRP.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));
    PRP.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2z));

    VPN.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3x));
    VPN.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3y));
    VPN.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p3z));

    VUP.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p4x));
    VUP.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p4y));
    VUP.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p4z));

    d = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_d));
    n = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_n));
    f = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_f));
    xmin = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_xmin));
    ymin = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_ymin));
    xmax = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_xmax));
    ymax = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_ymax));

    paraleloa = GTK_TOGGLE_BUTTON (chk_paraleloa)->active;

    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menua_PHIGSkamara(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame1,*hbox_frame2,*hbox_main,*vbox_esk,*vbox_ezk;
    GtkWidget *vbox_frm1,*vbox_frm2,*vbox_frm3,*vbox_frm4,*vbox_frmlei,*vbox_frmmug;
    GtkWidget *hbox_xmin,*hbox_ymin,*hbox_xmax,*hbox_ymax,*hbox_d,*hbox_n,*hbox_f;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox;
    GtkWidget *v1xhbox,*v1yhbox,*v1zhbox,*v2xhbox,*v2yhbox,*v2zhbox;
    GtkWidget *action_hbox;
    GtkWidget *frm_p1,*frm_p2,*frm_v1,*frm_v2,*frm_lei,*frm_mug;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2;
    GtkWidget *lbl_x3,*lbl_y3,*lbl_z3,*lbl_x4,*lbl_y4,*lbl_z4;
    GtkWidget *lbl_xmin,*lbl_xmax,*lbl_ymin,*lbl_ymax;
    GtkWidget *lbl_d,*lbl_n,*lbl_f;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - PHIGS kamara");
    gtk_widget_set_usize(lei,650,500);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);

    vbox = gtk_vbox_new(FALSE,0);
    hbox_main = gtk_hbox_new(FALSE,0);
    vbox_esk = gtk_vbox_new(FALSE,0);
    hbox_frame1 = gtk_hbox_new(FALSE,0);
    hbox_frame2 = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    vbox_frm3 = gtk_vbox_new(FALSE,0);
    vbox_frm4 = gtk_vbox_new(FALSE,0);
    vbox_frmlei = gtk_vbox_new(FALSE,0);
    vbox_frmmug = gtk_vbox_new(FALSE,0);
    hbox_xmin = gtk_hbox_new(FALSE,0);
    hbox_ymin = gtk_hbox_new(FALSE,0);
    hbox_xmax = gtk_hbox_new(FALSE,0);
    hbox_ymax = gtk_hbox_new(FALSE,0);
    hbox_d = gtk_hbox_new(FALSE,0);
    hbox_n = gtk_hbox_new(FALSE,0);
    hbox_f = gtk_hbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    v1xhbox = gtk_hbox_new(FALSE,0);
    v1yhbox = gtk_hbox_new(FALSE,0);
    v1zhbox = gtk_hbox_new(FALSE,0);
    v2xhbox = gtk_hbox_new(FALSE,0);
    v2yhbox = gtk_hbox_new(FALSE,0);
    v2zhbox = gtk_hbox_new(FALSE,0);
    vbox_ezk = gtk_vbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);

    frm_p1 = gtk_frame_new("VRP (jatorri berria):");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("PRP (proiekzio punt.):");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);
    frm_v1 = gtk_frame_new("VPN (begiratze bek.):");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_v2 = gtk_frame_new("VUP (goranzko bek.):");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);
    frm_lei = gtk_frame_new("Proiekzio leihoa:");
    gtk_frame_set_label_align(GTK_FRAME(frm_lei),0.5,0.0);
    frm_mug = gtk_frame_new("Mugaketa neurriak:");
    gtk_frame_set_label_align(GTK_FRAME(frm_mug),0.5,0.0);
    
    
    lbl_mezua = gtk_label_new("Kamararen ezaugarriak aukeratu:");

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_px),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_px),(gfloat)nerekam.VRP.x);
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_py),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_py),(gfloat)nerekam.VRP.y);
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_pz),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_pz),(gfloat)nerekam.VRP.z);
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p2x),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2x),(gfloat)nerekam.PRP.x);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p2y),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2y),(gfloat)nerekam.PRP.y);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p2z),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2z),(gfloat)nerekam.PRP.z);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    gtk_box_pack_start(GTK_BOX(hbox_frame1),frm_p1,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame1),frm_p2,FALSE,FALSE,10);

/********************************/
    lbl_x3 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(v1xhbox), lbl_x3, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3x = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p3x),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p3x),(gfloat)nerekam.VPN.x);
    gtk_box_pack_start (GTK_BOX(v1xhbox), spn_p3x, TRUE, TRUE, 20);

    lbl_y3 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(v1yhbox),lbl_y3,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3y = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p3y),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p3y),(gfloat)nerekam.VPN.y);
    gtk_box_pack_start (GTK_BOX(v1yhbox), spn_p3y, TRUE, TRUE, 20);

    lbl_z3 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(v1zhbox),lbl_z3,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p3z = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p3z),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p3z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p3z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p3z),(gfloat)nerekam.VPN.z);
    gtk_box_pack_start (GTK_BOX(v1zhbox), spn_p3z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm3),v1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm3),v1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm3),v1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_v1), vbox_frm3);

    lbl_x4 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(v2xhbox), lbl_x4, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p4x = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p4x),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p4x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p4x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p4x),(gfloat)nerekam.VUP.x);
    gtk_box_pack_start (GTK_BOX(v2xhbox), spn_p4x, TRUE, TRUE, 20);

    lbl_y4 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(v2yhbox),lbl_y4,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p4y = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p4y),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p4y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p4y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p4y),(gfloat)nerekam.VUP.y);
    gtk_box_pack_start (GTK_BOX(v2yhbox), spn_p4y, TRUE, TRUE, 20);

    lbl_z4 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(v2zhbox),lbl_z4,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p4z = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_p4z),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p4z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p4z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p4z),(gfloat)nerekam.VUP.z);
    gtk_box_pack_start (GTK_BOX(v2zhbox), spn_p4z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm4),v2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm4),v2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm4),v2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_v2), vbox_frm4);

    gtk_box_pack_start(GTK_BOX(hbox_frame2),frm_v1,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame2),frm_v2,FALSE,FALSE,10);

    chk_paraleloa = gtk_check_button_new_with_label ( "Paraleloa" );
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_paraleloa),nerekam.paraleloa);

    gtk_box_pack_start(GTK_BOX(vbox_ezk),hbox_frame1,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_ezk),hbox_frame2,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_ezk),chk_paraleloa,FALSE,FALSE,10);

    gtk_box_pack_start(GTK_BOX(hbox_main),vbox_ezk,FALSE,FALSE,10);

    /********************************/

    lbl_xmin = gtk_label_new("Xmin:");
    gtk_box_pack_start (GTK_BOX(hbox_xmin), lbl_xmin, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_xmin = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_xmin),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_xmin), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_xmin),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_xmin),(gfloat)nerekam.xmin);
    gtk_box_pack_start (GTK_BOX(hbox_xmin), spn_xmin, TRUE, TRUE, 20);

    lbl_ymin = gtk_label_new("Ymin:");
    gtk_box_pack_start (GTK_BOX(hbox_ymin), lbl_ymin, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_ymin = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_ymin),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_ymin), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_ymin),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_ymin),(gfloat)nerekam.ymin);
    gtk_box_pack_start (GTK_BOX(hbox_ymin), spn_ymin, TRUE, TRUE, 20);

    lbl_xmax = gtk_label_new("Xmax:");
    gtk_box_pack_start (GTK_BOX(hbox_xmax), lbl_xmax, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_xmax = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_xmax),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_xmax), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_xmax),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_xmax),(gfloat)nerekam.xmax);
    gtk_box_pack_start (GTK_BOX(hbox_xmax), spn_xmax, TRUE, TRUE, 20);

    lbl_ymax = gtk_label_new("Ymax:");
    gtk_box_pack_start (GTK_BOX(hbox_ymax), lbl_ymax, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_ymax = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_ymax),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_ymax), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_ymax),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_ymax),(gfloat)nerekam.ymax);
    gtk_box_pack_start (GTK_BOX(hbox_ymax), spn_ymax, TRUE, TRUE, 20);

    lbl_d = gtk_label_new("d:");
    gtk_box_pack_start (GTK_BOX(hbox_d), lbl_d, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_d = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_d),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_d), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_d),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_d),(gfloat)(nerekam.PRP.z - nerekam.pplanoa));
    gtk_box_pack_start (GTK_BOX(hbox_d), spn_d, TRUE, TRUE, 20);

    gtk_box_pack_start (GTK_BOX(vbox_frmlei), hbox_xmin, TRUE, TRUE, 10);
    gtk_box_pack_start (GTK_BOX(vbox_frmlei), hbox_ymin, TRUE, TRUE, 10);
    gtk_box_pack_start (GTK_BOX(vbox_frmlei), hbox_xmax, TRUE, TRUE, 10);
    gtk_box_pack_start (GTK_BOX(vbox_frmlei), hbox_ymax, TRUE, TRUE, 10);
    gtk_box_pack_start (GTK_BOX(vbox_frmlei), hbox_d, TRUE, TRUE, 10);

    gtk_container_add (GTK_CONTAINER(frm_lei), vbox_frmlei);


    lbl_n = gtk_label_new("Hurbil (n):");
    gtk_box_pack_start (GTK_BOX(hbox_n), lbl_n, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_n = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_n),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_n), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_n),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_n),(gfloat)nerekam.n);
    gtk_box_pack_start (GTK_BOX(hbox_n), spn_n, TRUE, TRUE, 20);

    lbl_f = gtk_label_new("Urruti (f):");
    gtk_box_pack_start (GTK_BOX(hbox_f), lbl_f, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_f = gtk_spin_button_new (adj, 0, 2);
    gtk_widget_set_usize(GTK_WIDGET(spn_f),60,22);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_f), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_f),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_f),(gfloat)nerekam.f);
    gtk_box_pack_start (GTK_BOX(hbox_f), spn_f, TRUE, TRUE, 20);

    gtk_box_pack_start (GTK_BOX(vbox_frmmug), hbox_n, TRUE, TRUE, 10);
    gtk_box_pack_start (GTK_BOX(vbox_frmmug), hbox_f, TRUE, TRUE, 10);

    gtk_container_add (GTK_CONTAINER(frm_mug), vbox_frmmug);

    gtk_box_pack_start(GTK_BOX(vbox_esk),frm_lei,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_esk),frm_mug,FALSE,FALSE,10);

    gtk_box_pack_start(GTK_BOX(hbox_main),vbox_esk,FALSE,FALSE,10);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (PHIGSkamara_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_main,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame1);

    gtk_widget_show(lbl_x3);
    gtk_widget_show(spn_p3x);
    gtk_widget_show(lbl_y3);
    gtk_widget_show(spn_p3y);
    gtk_widget_show(lbl_z3);
    gtk_widget_show(spn_p3z);
    gtk_widget_show(v1xhbox);
    gtk_widget_show(v1yhbox);
    gtk_widget_show(v1zhbox);
    gtk_widget_show(vbox_frm3);
    gtk_widget_show(lbl_x4);
    gtk_widget_show(spn_p4x);
    gtk_widget_show(lbl_y4);
    gtk_widget_show(spn_p4y);
    gtk_widget_show(lbl_z4);
    gtk_widget_show(spn_p4z);
    gtk_widget_show(v2xhbox);
    gtk_widget_show(v2yhbox);
    gtk_widget_show(v2zhbox);
    gtk_widget_show(vbox_frm4);
    gtk_widget_show(frm_v1);
    gtk_widget_show(frm_v2);
    gtk_widget_show(hbox_frame2);
    gtk_widget_show(chk_paraleloa);
    gtk_widget_show(vbox_ezk);

    gtk_widget_show(lbl_xmin);
    gtk_widget_show(spn_xmin);
    gtk_widget_show(hbox_xmin);
    gtk_widget_show(lbl_ymin);
    gtk_widget_show(spn_ymin);
    gtk_widget_show(hbox_ymin);
    gtk_widget_show(lbl_xmax);
    gtk_widget_show(spn_xmax);
    gtk_widget_show(hbox_xmax);
    gtk_widget_show(lbl_ymax);
    gtk_widget_show(spn_ymax);
    gtk_widget_show(hbox_ymax);
    gtk_widget_show(lbl_d);
    gtk_widget_show(spn_d);
    gtk_widget_show(hbox_d);
    gtk_widget_show(vbox_frmlei);
    gtk_widget_show(frm_lei);
    gtk_widget_show(lbl_n);
    gtk_widget_show(spn_n);
    gtk_widget_show(hbox_n);
    gtk_widget_show(lbl_f);
    gtk_widget_show(spn_f);
    gtk_widget_show(hbox_f);
    gtk_widget_show(vbox_frmmug);
    gtk_widget_show(frm_mug);
    gtk_widget_show(vbox_esk);

    gtk_widget_show(hbox_main);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void kamaratontoa_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    puntua3 p1,p2;

    p1.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    p1.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    p1.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    p2.x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
    p2.y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));
    p2.z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2z));
    mezua("hori da eta!","orain kalkulatu irudia...",mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menua_kamaratontoa(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1,*vbox_frm2;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox,*action_hbox;
    GtkWidget *frm_p1,*frm_p2;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    double luz;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Kamara tontoa");
    gtk_widget_set_usize(lei,390,255);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);

    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);
    frm_p1 = gtk_frame_new("Kamara dagoen puntua:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Begiratzen duen puntua:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);

    lbl_mezua = gtk_label_new("Kamararen ezaugarriak aukeratu:");

    luz = sqrt(nerekam.VPN.x*nerekam.VPN.x + nerekam.VPN.y*nerekam.VPN.y + nerekam.VPN.z*nerekam.VPN.z);
    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_px),(gfloat)((nerekam.VPN.x+nerekam.VRP.x)*nerekam.PRP.z/luz));
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_py),(gfloat)((nerekam.VPN.y+nerekam.VRP.y)*nerekam.PRP.z/luz));
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_pz),(gfloat)((nerekam.VPN.z+nerekam.VRP.z)*nerekam.PRP.z/luz));
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2x),(gfloat)nerekam.VRP.x);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2y),(gfloat)nerekam.VRP.y);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(spn_p2z),(gfloat)nerekam.VRP.z);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (kamaratontoa_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p2,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
void menua_atzeaurpegiakezabatu(GtkWidget *widget, gpointer data)
{
    GtkWidget *lag;
    int aukera;
    char buf[100];
    
    lag = gtk_item_factory_get_item(item_factory,"/Kamara/Atze aurpegiak ezkutatu");
    if (lag == NULL) return;
    else {
        aukera = GTK_CHECK_MENU_ITEM(lag)->active;
        sprintf(buf,"%d da aukera",aukera);
        mezua("aukeratutakoa",buf,mezuaONARTU,NULL);
    }
    redraw();
}
/************************************************************/
void menua_atzeaurpegiakalderantziz(GtkWidget *widget, gpointer data)
{
    
    mezua("ongi da","egina!",mezuaONARTU,NULL);
    redraw();
}
/************************************************************/
static void kamarakonfiguratu_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    int kamara_mota,interpolazio_mota;

    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_ertz))) {
        kamara_mota = KAMARA_ERTZAK;
    } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_span))) {
        kamara_mota = KAMARA_SPAN_SCANLINE;
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_flat))) {
            interpolazio_mota = KAMARA_FLAT;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_gouraud))) {
            interpolazio_mota = KAMARA_GOURAUD;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_phong))) {
            interpolazio_mota = KAMARA_PHONG;
        }
    } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_ray))) {
        kamara_mota = KAMARA_RAY_TRACING;
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_flat))) {
            interpolazio_mota = KAMARA_FLAT;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_gouraud))) {
            interpolazio_mota = KAMARA_GOURAUD;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_phong))) {
            interpolazio_mota = KAMARA_PHONG;
        }
    }
    
    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

static void kamarakonfiguratu_toggled(GtkWidget *widget, gpointer data)
{
    if (widget == rdb_ertz) {
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),FALSE);
    } else if (widget == rdb_span) {
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),TRUE);
    } else if (widget == rdb_ray) {
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),TRUE);
    } else {
        mezua("ez da posible!","ez du balio",mezuaONARTU,NULL);
    }
}

void menua_kamarakonfiguratu(GtkWidget *widget, gpointer data)
{
    int kamara_mota,interpolazio_mota;

    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1,*vbox_frm2;
    GtkWidget *action_hbox;
    GtkWidget *frm_p1,*frm_p2;
    GtkWidget *lbl_mezua;
    GtkWidget *cmd_accept,*cmd_cancel;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Kamara konfiguratu");
    gtk_widget_set_usize(lei,390,255);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);


    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);
    frm_p1 = gtk_frame_new("Kamara mota:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Interpolazio algoritmoa:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);

    lbl_mezua = gtk_label_new("Aukeratu kamararen konfigurazioa:");

    rdb_ertz = gtk_radio_button_new_with_label(NULL,"Ertzak");
    gtk_signal_connect_object (GTK_OBJECT (rdb_ertz), "toggled",
                               GTK_SIGNAL_FUNC (kamarakonfiguratu_toggled),
                               GTK_OBJECT (rdb_ertz));
    gtk_box_pack_start(GTK_BOX(vbox_frm1),rdb_ertz,FALSE,FALSE,10);
    rdb_span = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_ertz)),"Span Scanline");
    gtk_signal_connect_object (GTK_OBJECT (rdb_span), "toggled",
                               GTK_SIGNAL_FUNC (kamarakonfiguratu_toggled),
                               GTK_OBJECT (rdb_span));
    gtk_box_pack_start(GTK_BOX(vbox_frm1),rdb_span,FALSE,FALSE,10);
    rdb_ray = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_ertz)),"Ray Tracing");
    gtk_signal_connect_object (GTK_OBJECT (rdb_ray), "toggled",
                               GTK_SIGNAL_FUNC (kamarakonfiguratu_toggled),
                               GTK_OBJECT (rdb_ray));
    gtk_widget_set_sensitive(GTK_WIDGET(rdb_ray),FALSE);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),rdb_ray,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    rdb_flat = gtk_radio_button_new_with_label(NULL,"Flat");
    gtk_box_pack_start(GTK_BOX(vbox_frm2),rdb_flat,FALSE,FALSE,10);
    rdb_gouraud = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_flat)),"Gouraud");
    gtk_box_pack_start(GTK_BOX(vbox_frm2),rdb_gouraud,FALSE,FALSE,10);
    rdb_phong = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_flat)),"Phong");
    gtk_box_pack_start(GTK_BOX(vbox_frm2),rdb_phong,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    kamara_mota= KAMARA_ERTZAK;
    switch (kamara_mota) {
    case KAMARA_ERTZAK:
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_ertz),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),FALSE);
        break;
    case KAMARA_SPAN_SCANLINE:
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_span),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),TRUE);
        break;
    case KAMARA_RAY_TRACING:
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_ray),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_flat),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_gouraud),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(rdb_phong),TRUE);
        break;
    }

    interpolazio_mota = KAMARA_PHONG;
    switch (interpolazio_mota) {
    case KAMARA_FLAT:gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_flat),TRUE);break;
    case KAMARA_GOURAUD:gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_gouraud),TRUE);break;
    case KAMARA_PHONG:gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rdb_phong),TRUE);break;
    }

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (kamarakonfiguratu_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p2,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);
    
    gtk_widget_show(lbl_mezua);
    gtk_widget_show(rdb_ertz);
    gtk_widget_show(rdb_span);
    gtk_widget_show(rdb_ray);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(rdb_flat);
    gtk_widget_show(rdb_gouraud);
    gtk_widget_show(rdb_phong);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void bistakkonfiguratu_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    bista_pos_x = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_px));
    bista_pos_y = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_py));
    bista_pos_z = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_pz));

    bista_tam_zab = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2x));
    bista_tam_alt = (double) gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(spn_p2y));

    bista_prop = GTK_TOGGLE_BUTTON (chk_proportzioa)->active;

    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menua_bistakkonfiguratu(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1,*vbox_frm2;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox,*action_hbox;
    GtkWidget *frm_p1,*frm_p2;
    GtkWidget *lbl_mezua;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkWidget *hbox_prop;
    GtkAdjustment *adj;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Bistak konfiguratu");
    gtk_widget_set_usize(lei,390,295);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);


    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_frm2 = gtk_vbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    hbox_prop = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);
    frm_p1 = gtk_frame_new("Begiratzen den puntua:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Lehioen tamaina:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);

    lbl_mezua = gtk_label_new("Aukeratu bisten konfigurazioa:");

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (bista_pos_x, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (bista_pos_y, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (bista_pos_z, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_frm1);

    lbl_x2 = gtk_label_new("Zabalera:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (bista_tam_zab, 0.0, 1000.0, 1.0, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Altura:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (bista_tam_alt, 0.0, 1000.0, 1.0, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
/*
    adj = (GtkAdjustment *)gtk_adjustment_new (1.0, 0.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);
*/
    
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_frm2);

    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p1,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_p2,TRUE,TRUE,10);

    chk_proportzioa = gtk_check_button_new_with_label("Proportzioak mantendu");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chk_proportzioa),bista_prop);

    gtk_box_pack_start(GTK_BOX(hbox_prop),chk_proportzioa,TRUE,TRUE,10);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (bistakkonfiguratu_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_prop,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);
    
    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
//    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_frm2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(chk_proportzioa);
    gtk_widget_show(hbox_prop);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
