
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;

static GtkWidget *txt_ID;
static GtkWidget *txt_erpin;
static GtkWidget *txt_aurpegi;



/************************************************************/
static void informazioa_itxibutton( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(widget));
}

static void informazioa_aukeratu(GtkWidget *widget, gpointer data)
{
    char lag[20];

    gtk_entry_set_text(GTK_ENTRY(txt_ID),gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(data)->entry)));
    sprintf(lag,"auskalo");
    gtk_entry_set_text(GTK_ENTRY(txt_erpin),lag);
    sprintf(lag,"nork daki");
    gtk_entry_set_text(GTK_ENTRY(txt_aurpegi),lag);
}

void menua_ikusigorde(GtkWidget *widget, gpointer data)
{
mezua("zure aginduetara!","baina ez dakit zer ikusi edo gorde nahi duzun...",mezuaONARTU,NULL);
}
void menua_informazioa(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox;
    GtkWidget *lbl_aukera;
    GtkWidget *cmd_itxi;
    GtkWidget *cmb_aukera;
    GtkWidget *tbl_info;
    GtkWidget *lbl_erpin, *lbl_aurpegi, *lbl_ID;
    char lag[20];
    
    GList *glist;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);
    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Informazioa");
    gtk_widget_set_usize(lei,210,200);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,10);
    hbox = gtk_hbox_new(FALSE,0);

    lbl_aukera = gtk_label_new("Aukeratu objetua:");

    glist = NULL;
    glist = g_list_append(glist,"lehenengoa");
    glist = g_list_append(glist,"abioia?");
    glist = g_list_append(glist,"beste bat");
    glist = g_list_append(glist,"...");
    
    cmb_aukera = gtk_combo_new();
    gtk_combo_set_popdown_strings(GTK_COMBO(cmb_aukera),glist);
    gtk_combo_set_case_sensitive(GTK_COMBO(cmb_aukera),TRUE);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(cmb_aukera)->entry),FALSE);
    
    gtk_signal_connect(GTK_OBJECT(GTK_COMBO(cmb_aukera)->entry), "changed",
                              GTK_SIGNAL_FUNC (informazioa_aukeratu), (gpointer)cmb_aukera);

    tbl_info = gtk_table_new(3,2,FALSE);

    lbl_ID = gtk_label_new("ID:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),lbl_ID,0,1,0,1);
    txt_ID = gtk_entry_new_with_max_length(20);
    gtk_widget_set_usize(GTK_WIDGET(txt_ID),80,22);
    gtk_entry_set_editable(GTK_ENTRY(txt_ID),FALSE);
    sprintf(lag,"dena gezurra?");
    gtk_entry_set_text(GTK_ENTRY(txt_ID),lag);
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),txt_ID,1,2,0,1);

    lbl_erpin = gtk_label_new("Erpin kopurua:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),lbl_erpin,0,1,1,2);
    txt_erpin = gtk_entry_new_with_max_length(10);
    gtk_widget_set_usize(GTK_WIDGET(txt_erpin),80,22);
    gtk_entry_set_editable(GTK_ENTRY(txt_erpin),FALSE);
    sprintf(lag,"auskalo");
    gtk_entry_set_text(GTK_ENTRY(txt_erpin),lag);
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),txt_erpin,1,2,1,2);

    lbl_aurpegi = gtk_label_new("Aurpegi kopurua:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),lbl_aurpegi,0,1,2,3);
    txt_aurpegi = gtk_entry_new_with_max_length(10);
    gtk_widget_set_usize(GTK_WIDGET(txt_aurpegi),80,22);
    gtk_entry_set_editable(GTK_ENTRY(txt_aurpegi),FALSE);
    sprintf(lag,"nork daki");
    gtk_entry_set_text(GTK_ENTRY(txt_aurpegi),lag);
    gtk_table_attach_defaults(GTK_TABLE(tbl_info),txt_aurpegi,1,2,2,3);

    cmd_itxi = gtk_button_new_with_label ("Itxi");

    
    gtk_signal_connect (GTK_OBJECT (lei), "destroy",
                        GTK_SIGNAL_FUNC (informazioa_itxibutton), GTK_OBJECT(lei));

    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);

    gtk_signal_connect_object (GTK_OBJECT (cmd_itxi), "clicked",
                               GTK_SIGNAL_FUNC (informazioa_itxibutton),
                               GTK_OBJECT (lei));

    gtk_container_add (GTK_CONTAINER (lei),vbox);
    gtk_box_pack_start(GTK_BOX(vbox),lbl_aukera,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),cmb_aukera,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),tbl_info,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(hbox),cmd_itxi,TRUE,TRUE,0);

    gtk_widget_show (cmd_itxi);
    gtk_widget_show (lbl_aukera);
    gtk_widget_show (cmb_aukera);

    gtk_widget_show (lbl_ID);
    gtk_widget_show (txt_ID);
    gtk_widget_show (lbl_erpin);
    gtk_widget_show (txt_erpin);
    gtk_widget_show (lbl_aurpegi);
    gtk_widget_show (txt_aurpegi);
    gtk_widget_show (tbl_info);
    
    gtk_widget_show (hbox);
    gtk_widget_show (vbox);

    gtk_widget_show (lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
