
#include <gtk/gtk.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "mezua.h"

struct info {
    GtkWidget *lei;
    int mota;
    mezua_erantzuna fun;
    GtkWidget *txt_mezua;
};

static void mezua_cmd_bai_clicked( gpointer data )
{
    char *m;

    if (((struct info *)data)->mota & mezuaTESTUA && ((struct info *)data)->txt_mezua != NULL)
        m = strdup(gtk_entry_get_text(GTK_ENTRY(((struct info *)data)->txt_mezua)));
    else
        m = NULL;
    gtk_widget_destroy(GTK_WIDGET(((struct info *)data)->lei));
    if (((struct info *)data)->fun != NULL)
        MEZUA_ERANTZUNA(((struct info *)data)->fun)(mezuaBAI, m);
}

static void mezua_cmd_ez_clicked( gpointer data )
{
    char *m;

    if (((struct info *)data)->mota & mezuaTESTUA && ((struct info *)data)->txt_mezua != NULL)
        m = strdup(gtk_entry_get_text(GTK_ENTRY(((struct info *)data)->txt_mezua)));
    else
        m = NULL;
    gtk_widget_destroy(GTK_WIDGET(((struct info *)data)->lei));
    if (((struct info *)data)->fun != NULL)
        MEZUA_ERANTZUNA(((struct info *)data)->fun)(mezuaEZ, m);
}

static void mezua_cmd_onartu_clicked( gpointer data )
{
    char *m;

    if (((struct info *)data)->mota & mezuaTESTUA && ((struct info *)data)->txt_mezua != NULL)
        m = strdup(gtk_entry_get_text(GTK_ENTRY(((struct info *)data)->txt_mezua)));
    else
        m = NULL;
    gtk_widget_destroy(GTK_WIDGET(((struct info *)data)->lei));
    if (((struct info *)data)->fun != NULL)
        MEZUA_ERANTZUNA(((struct info *)data)->fun)(mezuaONARTU, m);
}

static void mezua_cmd_ezeztatu_clicked( gpointer data )
{
    char *m;

    if (((struct info *)data)->mota & mezuaTESTUA && ((struct info *)data)->txt_mezua != NULL)
        m = strdup(gtk_entry_get_text(GTK_ENTRY(((struct info *)data)->txt_mezua)));
    else
        m = NULL;
    gtk_widget_destroy(GTK_WIDGET(((struct info *)data)->lei));
    if (((struct info *)data)->fun != NULL)
        MEZUA_ERANTZUNA(((struct info *)data)->fun)(mezuaEZEZTATU, m);
}

static int mezua_lei_delete( gpointer data )
{
    char *m;

    if (((struct info *)data)->mota & mezuaTESTUA && ((struct info *)data)->txt_mezua != NULL)
        m = gtk_entry_get_text(GTK_ENTRY(((struct info *)data)->txt_mezua));
    else
        m = NULL;
    if (((struct info *)data)->mota & mezuaITXIEZINA) {
        return TRUE;
    } else {
        gtk_widget_destroy(GTK_WIDGET(((struct info *)data)->lei));
        if (((struct info *)data)->fun != NULL)
            MEZUA_ERANTZUNA(((struct info *)data)->fun)(mezuaITXIA, m);
        return FALSE;
    }
}

void mezua(const char *izenburua,const char *mezua,int mota,mezua_erantzuna fun)
{
    GtkWidget *lei;
    GtkWidget *lbl_mezua;
    GtkWidget *txt_testua;
    GtkWidget *cmd_bai,*cmd_ez,*cmd_onartu,*cmd_ezeztatu;
    GtkWidget *vbox_main,*hbox_action;
    struct info *data;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    if (izenburua != NULL)
        gtk_window_set_title(GTK_WINDOW(lei), izenburua);
    else
        gtk_window_set_title(GTK_WINDOW(lei), "Mezua");
    gtk_container_set_border_width (GTK_CONTAINER (lei), 10);
//    gtk_widget_set_usize(lei,240,220);  // ?!!!!!!!!!!!!!?
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    data = (struct info *)malloc(sizeof(struct info));
    data->mota = mota;
//    printf("mota: %d == %d\n",mota,data->mota);
    data->lei = lei;
    data->fun = fun;

    vbox_main = gtk_vbox_new(FALSE,0);
    hbox_action = gtk_hbox_new(FALSE,0);

    lbl_mezua = gtk_label_new(mezua);
    gtk_box_pack_start(GTK_BOX(vbox_main),lbl_mezua,FALSE,FALSE,5);
    gtk_widget_show(lbl_mezua);

    if (mota & mezuaTESTUA)
    {
//        printf("testua\n");
        txt_testua = gtk_entry_new();
        gtk_box_pack_start(GTK_BOX(vbox_main),txt_testua,TRUE,TRUE,5);
        gtk_widget_show(txt_testua);
    } else {
        txt_testua = NULL;
    }
    data->txt_mezua = txt_testua;
    
    if (mota & mezuaBAI)
    {
//        printf("bai\n");
        cmd_bai = gtk_button_new_with_label("Bai");
        gtk_widget_set_usize(cmd_bai,100,22);
        gtk_signal_connect_object (GTK_OBJECT (cmd_bai), "clicked",
                                   GTK_SIGNAL_FUNC (mezua_cmd_bai_clicked),
                                   (gpointer)data);
        gtk_box_pack_start(GTK_BOX(hbox_action),cmd_bai,TRUE,FALSE,5);
        gtk_widget_show(cmd_bai);
    } else {
        cmd_bai = NULL;
    }

    if (mota & mezuaEZ)
    {
//        printf("ez\n");
        cmd_ez = gtk_button_new_with_label("Ez");
        gtk_widget_set_usize(cmd_ez,100,22);
        gtk_signal_connect_object (GTK_OBJECT (cmd_ez), "clicked",
                                   GTK_SIGNAL_FUNC (mezua_cmd_ez_clicked),
                                   (gpointer)data);
        gtk_box_pack_start(GTK_BOX(hbox_action),cmd_ez,TRUE,FALSE,5);
        gtk_widget_show(cmd_ez);
    } else {
        cmd_ez = NULL;
    }

    if (mota & mezuaONARTU)
    {
//        printf("onartu\n");
        cmd_onartu = gtk_button_new_with_label("Onartu");
        gtk_widget_set_usize(cmd_onartu,100,22);
        gtk_signal_connect_object (GTK_OBJECT (cmd_onartu), "clicked",
                                   GTK_SIGNAL_FUNC (mezua_cmd_onartu_clicked),
                                   (gpointer)data);
        gtk_box_pack_start(GTK_BOX(hbox_action),cmd_onartu,TRUE,FALSE,5);
        gtk_widget_show(cmd_onartu);
    } else {
        cmd_onartu = NULL;
    }

    if (mota & mezuaEZEZTATU)
    {
//        printf("ezeztatu\n");
        cmd_ezeztatu = gtk_button_new_with_label("Ezeztatu");
        gtk_widget_set_usize(cmd_ezeztatu,100,22);
        gtk_signal_connect_object (GTK_OBJECT (cmd_ezeztatu), "clicked",
                                   GTK_SIGNAL_FUNC (mezua_cmd_ezeztatu_clicked),
                                   (gpointer)data);
        gtk_box_pack_start(GTK_BOX(hbox_action),cmd_ezeztatu,TRUE,FALSE,5);
        gtk_widget_show(cmd_ezeztatu);
    } else {
        cmd_ezeztatu = NULL;
    }

    gtk_box_pack_start(GTK_BOX(vbox_main),hbox_action,FALSE,FALSE,20);
    gtk_container_add (GTK_CONTAINER (lei),vbox_main);

    // atera nahi duen galdetzeko
    gtk_signal_connect_object (GTK_OBJECT (lei), "delete_event",
                               GTK_SIGNAL_FUNC (mezua_lei_delete),
                               (gpointer)data);

    gtk_widget_show(vbox_main);
    gtk_widget_show(hbox_action);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}

