#include <assert.h>
#include <malloc.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "render.h"
#include "mezua.h"
#include "definiz.h"

#define ERTZ_AUR_HASI          1
#define ERTZ_AUR_BUKATU        2
#define ERTZ_KASURIK_EZ        3


#define max(a,b)                           (a<b?b:a)
#define min(a,b)                           (a>b?b:a)
#define draw_point(buffer,x,y,rowstride)   ((long int *)buffer)[y*rowstride+x] = 0x00FFFFFF



static void draw_line(long *buffer, int x1, int y1, int x2, int y2, int xmax, int ymax)
{
    int x,y;
    int p1x,p1y,p2x,p2y;

    if (x1 == x2) {
        x = x1;
        for (y=min(y1,y2);y<=max(y1,y2) && y<ymax;y++)
            if (y >= 0 && x >= 0 && y<ymax && x<xmax)
                draw_point(buffer,x,y,xmax);
    } else if (y1 == y2) {
        y = y1;
        for (x=min(x1,x2);x<=max(x1,x2) && x<xmax;x++)
            if (y >= 0 && x >= 0 && y<ymax && x<xmax)
                draw_point(buffer,x,y,xmax);
    } else if ((max(x1,x2)-min(x1,x2)) >= max(y1,y2)-min(y1,y2)) {
        if (x1 > x2) {
            p1x = x2;
            p1y = y2;
            p2x = x1;
            p2y = y1;
        } else {
            p1x = x1;
            p1y = y1;
            p2x = x2;
            p2y = y2;
        }
        
        for (x=p1x;x<=p2x && x<xmax;x++)
        {
            y =((double)(p2y-p1y)/(double)(p2x-p1x)*(double)(x-p1x)) + p1y;
            if (y >= 0 && x >= 0 && y<ymax && x<xmax)
                draw_point(buffer,x,y,xmax);
        }
    } else {
        if (y1 > y2) {
            p1x = x2;
            p1y = y2;
            p2x = x1;
            p2y = y1;
        } else {
            p1x = x1;
            p1y = y1;
            p2x = x2;
            p2y = y2;
        }
        
        for (y=p1y;y<=p2y && y<ymax;y++)
        {
            x =((double)(p2x-p1x)/(double)(p2y-p1y)*(double)(y-p1y)) + p1x;
            if (y >= 0 && x >= 0 && y<ymax && x<xmax)
            {
                draw_point(buffer,x,y,xmax);
            }
        }
    }
}

void Render_Ertzak(unsigned long* RenderBuffer, int Width, int Height, int Rowstride,
                   kamara *kamptr, argilista *argiak, objektua *objptr)
{
int ind;

for(ind=0; ind<Width*Height; ind++)
        RenderBuffer[ind] = 0x00000000;
draw_line(RenderBuffer, 15,45, 200,187, Width,Height);
}


#define SCAN_Y 1
#define SCAN_X 404
#define GIA_KOLOREA 0x00000000



void Render_SpanScanline(unsigned long* RenderBuffer, signed Width, signed Height, signed Scanline,
                         kamara* kam, argilista *argiak, objektua *objptr)
{
}
